;;;CADALYST  01/06  AutoLISP Solutions  (c) 2006 Cadalyst

;; ALIGNIT.LSP
;; a program to align entities to any chosen entity.
;; Program by Tony Hotchkiss.

(defun err (s)
  (if (= s "Function cancelled")
    (princ "\nALIGNIT - cancelled: ")
    (progn (princ "\nALIGNIT - Error: ")
	   (princ s)
	   (terpri)
    ) ;_ end of progn
  ) ;_ end of if
  (resetting)
  (princ "SYSTEM VARIABLES have been reset\n")
  (princ)
) ; err
(defun setv (systvar newval / x)
  (setq x (read (strcat systvar "1")))
  (set x (getvar systvar))
  (setvar systvar newval)
) ; setv
(defun setting ()
  (setq oerr *error*)
  (setq *error* err)
  (setv "BLIPMODE" 0)
  (setv "CMDECHO" 0)
) ; setting
(defun rsetv (systvar)
  (setq x (read (strcat systvar "1")))
  (setvar systvar (eval x))
) ; rsetv
(defun resetting ()
  (rsetv "BLIPMODE")
  (rsetv "CMDECHO")
  (setq *error* oerr)
) ; resetting

(defun alignit (/ al_f index_val doit max_x max_y)
  (vl-load-com)
  (setq	*thisdrawing* (vla-get-activedocument
			(vlax-get-acad-object)
		      )
	*modelspace*  (vla-get-ModelSpace *thisdrawing*)
  ) ;_ end of setq
  (setq	al_f "alignit.dcl"
	al_d "alignit"
  ) ;_ end of setq
  (setq index_val (load_dialog al_f))
  (setq doit 8)
  (while (> doit 1)
    (if	(not (new_dialog al_d index_val))
      (exit)
    ) ;_ end of if
    (draw-image)
    (action_tile "Top" "(done_dialog 3)")
    (action_tile "Bottom" "(done_dialog 4)")
    (action_tile "Left" "(done_dialog 5)")
    (action_tile "Right" "(done_dialog 6)")
    (setq doit (start_dialog))
    (cond
      ((= doit 3) (al_move 3))
      ((= doit 4) (al_move 4))
      ((= doit 5) (al_move 5))
      ((= doit 6) (al_move 6))
    ) ; cond
  ) ; while
  (unload_dialog index_val)
  (princ)
) ; alignit

(defun draw-image ()
  (setq x (dimx_tile "slide1"))
  (setq y (dimy_tile "slide1"))
  (start_image "slide1")
  (fill_image 0 0 x y -2)
  (end_image)
  (setq cen (list (fix (/ x 12)) (fix (/ y 12))))
  (setq	circles	6
	num	24
	rad	(fix (/ x 12))
	col	1
  ) ;_ end-of setq
  (repeat circles
    (image-circle cen rad num col)
    (start_image "slide1")
    (do-vector cen (polar cen (* pi 0.5) (/ y 2)) 5)
    (end_image)
    (setq cen (polar cen 0 (* 2 rad)))
  ) ;_ end-of repeat
) ;_ end of draw-image

(defun image-circle (cen rad num col / p1 p2 x1 x2 y1 y2)
  (setq	inc (/ (* 2 pi) num)
	ang 0
  ) ;_ setq
  (start_image "slide1")
  (repeat num
    (setq p1 (polar cen (setq ang (+ ang inc)) rad)
	  p2 (polar cen (+ ang inc) rad)
	  x1 (car p1)
	  y1 (cadr p1)
	  x2 (car p2)
	  y2 (cadr p2)
    ) ;_ setq
    (vector_image (fix x1) (fix y1) (fix x2) (fix y2) col)
  ) ;_ repeat
  (end_image)
) ;_ image-circle

(defun do-vector (point1 point2 col)
  (vector_image
    (fix (car point1))
    (fix (cadr point1))
    (fix (car point2))
    (fix (cadr point2))
    col
  ) ;_ end of vector_image
) ;_ end of do-vector
  
(defun al_move (carnum	 /	  ssetcount	    sslist   ename
		obj	 ssobj	  j	   car-func flevel   enxy
		dist	 base-pt  to-pt
	       )
  (setq	ssets	  (vla-get-selectionsets *thisdrawing*)
	ssetcount (vla-get-count ssets)
  ) ;_ end of setq
  (if (> ssetcount 0)
    (repeat ssetcount
      (vla-delete (vla-item ssets 0))
    ) ;_ end of repeat
  ) ;_ end of if
  (setq sslist (al_select))
  (setq	ename (car sslist)
	obj   (vlax-ename->vla-object ename)
	ssobj (cadr sslist)
	j     (- 1)
  ) ;_ end of setq
  (setq	car-func
	 (cond
	   ((= carnum 3) car)
	   ((= carnum 4) cadr)
	   ((= carnum 5) caddr)
	   ((= carnum 6) cadddr)
	 ) ; cond
  ) ; setq
  (setq flevel (car-func (xyval obj)))
  (repeat (vla-get-count ssobj)
    (setq obj (vla-item ssobj (setq j (1+ j))))
    (setq enxy (car-func (xyval obj)))
    (setq dist	  (- flevel enxy)
	  base-pt '(0 0 0)
    ) ;_ end of setq
    (setq to-pt
	   (cond
	     ((or (= carnum 3) (= carnum 4))
	      (list 0 dist 0)
	     )
	     ((or (= carnum 5) (= carnum 6))
	      (list dist 0 0)
	     )
	   ) ; cond
    ) ; setq
    (setq ename (vlax-vla-object->ename obj))
    (command "MOVE" ename "" base-pt to-pt)
  ) ; repeat
  (princ)
) ; al_move

(defun al_select ( / enfixed ssobj)
  (setq enfixed nil)
  (prompt "\nSelect the fixed entity ")
  (while (not enfixed)
    (setq enfixed (car (entsel)))
    (if	(not enfixed)
      (prompt "\nSelect an entity ")
    ) ;_ end of if
  ) ; while
  (prompt "\nSelect the entities to be aligned ")
  (setq ssobj (vla-add ssets "selection1"))
  (while (= (vla-get-count ssobj) 0)
    (vla-SelectOnScreen ssobj)
    (if	(= (vla-get-count ssobj) 0)
      (prompt "\nNo entities were selected ")
    ) ;_ end of if
  ) ; while
  (list enfixed ssobj)
) ; al_select

(defun xyval (obj / minpt maxpt topy bottmy leftx rightx)
  (vla-GetBoundingBox obj 'minpt 'maxpt)
  (setq	pt1    (vlax-safearray->list minpt)
	pt2    (vlax-safearray->list maxpt)
	topy   (cadr pt2)
	bottmy (cadr pt1)
	leftx  (car pt1)
	rightx (car pt2)
  ) ;_ end of setq
  (list topy bottmy leftx rightx)
) ;_ end of xyval

(defun c:ali ()
  (setting)
  (alignit)
  (resetting)
  (princ)
) ;_ end of defun
(prompt "\nCopyright (c) 2006 Tony Hotchkiss")
(prompt "Enter ALI to start.")
(princ)
